chiark / gitweb /
Fix "tests: drs-push-rejects: test unknown suite"
[dgit.git] / tests / tests / drs-push-rejects
index 6098da79a0cd0da4a685dc1210d0fdeed5af5116..f6f8882979e5b29ef79a089ba9915d76228fd970 100755 (executable)
@@ -10,20 +10,40 @@ t-worktree drs
 
 cd $p
 
+reporefs () {
+       (set -e
+       if test -d $tmp/git/$p.git; then
+               cd $tmp/git/$p.git
+               git show-ref
+       fi)
+}
+
 mustfail () {
        local wantmsg="$1"; shift
+       reporefs >$tmp/show-refs.pre-push
        set +e
        git push origin "$@" 2>&1 |tee $tmp/mustfail.txt
        ps="${PIPESTATUS[*]}"
        set -e
        case $ps in
-       "0 0")  fail "push unexpectedly succeeded: $*" ;;
+       "0 0")  fail "push unexpectedly succeeded (instead of: $wantmsg)" ;;
        *" 0")  ;;
        *)      fail "tee failed"  ;;
        esac
        if ! fgrep "$wantmsg" $tmp/mustfail.txt >/dev/null; then
                fail "error message not found"
        fi
+       reporefs >$tmp/show-refs.post-push
+       diff $tmp/show-refs.{pre,post}-push
+}
+
+mustsucceed () {
+       reporefs >$tmp/show-refs.pre-push
+       git push origin "$@"
+       reporefs >$tmp/show-refs.post-push
+       if diff $tmp/show-refs.{pre,post}-push >$tmp/show-refs.diff; then
+               fail "no refs updated"
+       fi
 }
 
 prep () {
@@ -32,7 +52,7 @@ prep () {
        cp $tmp/masters/* $tmp/.
        tag_signer='-u Senatus'
        tag_message="$p release $version for $suite ($csuite) [dgit]"
-       tag_name=debian/3-2_dummy1
+       tag_name=debian/$version
        push_spec1="HEAD:refs/dgit/$csuite"
        push_spec2="refs/tags/$tag_name"
        push_spec="$push_spec1 $push_spec2"
@@ -51,6 +71,39 @@ tag_signer='-a'
 mktag
 mustfail 'missing signature' $push_spec
 
+git cat-file tag $tag_name >goodtag
+
+for h in object type tag; do
+  for how in missing dupe; do
+
+    case $how in
+    missing) perl -pe 's/^tag /wombat$&/ if 1..m/^$/'  <goodtag >badtag ;;
+    dupe)   perl -pe 'print if 1..m/^$/ and m/^'$h' /' <goodtag >badtag ;;
+    esac
+
+    rm -f badtag.asc
+    gpg --detach-sign --armor -u Senatus badtag
+    cat badtag.asc >>badtag
+
+    set +e
+    LC_ALL=C git hash-object -w -t tag badtag >badtag.hash 2>badtag.err
+    rc=$?
+    set -e
+
+    if [ $rc = 128 ] && grep 'fatal: corrupt tag' badtag.err; then
+      continue
+    elif [ $rc != 0 ]; then
+      cat badtag.err
+      fail "could not make tag"
+    fi
+
+    read <badtag.hash badtag
+    git update-ref refs/tags/$tag_name $badtag
+
+    mustfail 'multiple headers '$h' in signed tag object' $push_spec
+  done
+done
+
 prep unstable sid
 tag_message='something'
 mktag
@@ -58,16 +111,89 @@ mustfail 'tag message not in expected format' $push_spec
 
 prep unstable sid
 mktag
-
 mustfail 'sid != sponge' HEAD:refs/dgit/sponge $push_spec2
 
 # fixme test --sig-policy-url string
 # fixme cannot test   reject "signature is not of type 00!";
 
-git push origin $push_spec
+prep unstable sid
+mktag
+mustfail 'push is missing tag ref update' $push_spec1
+mustfail 'push is missing head ref update' $push_spec2
+mustfail 'pushing unexpected ref' $push_spec HEAD:refs/wombat
+mustfail 'pushing multiple heads' $push_spec HEAD:refs/dgit/wombat
+mustfail 'pushing multiple tags' $push_spec HEAD:refs/tags/debian/wombat
+
+prep unstable sid
+mktag
+echo woody >$tmp/suites
+mustfail 'unknown suite' $push_spec
+cp $root/tests/suites $tmp/.
+
+# fixme:
+#    or reject "command string not understood";
+#    reject "unknown method" unless $mainfunc;
+
+
+prep unstable sid
+mktag
+cp $tmp/dm.gpg $tmp/dd.gpg
+mustfail 'key not found in keyrings' $push_spec
+
+prep unstable sid
+mktag HEAD~
+mustfail 'tag refers to wrong commit' $push_spec
+
+prep unstable sid
+mktag HEAD~:
+mustfail 'tag refers to wrong kind of object' $push_spec
 
+prep unstable sid
+tag_name=debian/wombat
 mktag
+#git update-ref debian/$version debian/wombat
+mustfail 'tag name in tag is wrong' \
+       refs/tags/debian/wombat:refs/tags/debian/$version $push_spec1
 
+prep unstable sid
+mktag
+mustsucceed $push_spec # succeeds
+
+mktag
 mustfail 'not replacing previously-pushed version' $push_spec
 
+prep_dm_mangle () {
+       prep unstable sid
+       perl -i.bak -pe '
+               next unless m/^fingerprint: 3A82860837A0CD32/i../^$/;
+       ' -e "$1" $tmp/dm.txt
+       tag_signer='-u Populus'
+       mktag
+}
+
+git commit --amend --message 'Make it not a fast forward'
+version=3-2_dummy2
+prep unstable sid
+mktag
+mustfail 'not fast forward on dgit branch' +$push_spec1 +$push_spec2
+
+git checkout v2
+version=3-2_dummy2
+
+prep_dm_mangle ''
+perl -i.bak -ne 'print if 1..s/(pari-extra).*\n/$1/' $tmp/dm.txt
+mustfail '' $push_spec # malformed (truncated) dm.txt; don't care about msg
+
+prep_dm_mangle 's/allow:/asponge:/i'
+mustfail 'missing Allow section in permission' $push_spec
+
+prep_dm_mangle 's/\bpari-extra\b/sponge/i'
+mustfail "package $p not allowed for key" $push_spec
+
+prep_dm_mangle 'y/0-9/5-90-4/ if m/^fingerprint:/i'
+mustfail "not in permissions list although in keyring" $push_spec
+
+prep_dm_mangle ''
+mustsucceed $push_spec # succeeds
+
 echo ok.